import sys
import time as t
import ast
import os
import pyautogui as gui
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC

####################
#### Parameters ####
####################

emailAddress = None # email of end user

# values below are required to be non-nil for script to work - redacted for anonymity
REDACTED_UNIVERSITY_LEARN_SITE = None
REDACTED_LEARN_CODE = None

##############
#### Code ####
##############

# get number of loops to perform from command line input if given
numLoops = int(sys.argv[1]) if str(sys.argv[1]).isnumeric else 0

# load all quiz IDs
quizDict = ast.literal_eval(open("idDictionary.txt","r").read())
quizIDs = []

# create list of quizIDs
for valList in quizDict.values():
    for val in valList:
        quizIDs.append(val)

# setting the value of weekNum to a week can allow for downloading files to a subdirectory - not necessary
weekNum = ""
downloadDir = os.path.join(os.getcwd(),"rawDownloads",weekNum)

fp = webdriver.FirefoxProfile()
fp.set_preference("browser.download.folderList", 2)
fp.set_preference("browser.download.manager.showWhenStarting", False)
fp.set_preference("browser.download.dir", downloadDir)
fp.set_preference("browser.helperApps.neverAsk.saveToDisk", "csv, application/csv, text/csv, application/libreoffice, application/calc, document/csv")


# navigate to page containing download links for the requested reports
driver = webdriver.Firefox(firefox_profile=fp)
driver.get("https://{REDACTED_UNIVERSITY_LEARN_URL}/d2l/custom/ReportingFramework/{REDACTED_LEARN_CODE}/StatusHome")
gui.typewrite(f"{emailAddress}", interval=0.03)
gui.press("enter")
# Wait here for user to clear duo security manually
element = WebDriverWait(driver, 50).until(
    EC.presence_of_element_located((By.ID, "DataExportRefreshButton"))
)


# In reports page
# set the view to 100 reports per page
gui.hotkey('shift','tab')
gui.press('1')
t.sleep(10)

# Download reports
# extra_increment moves the starting list item further down the page - can be used to compensate for reports requested by others, if present
pageSelectTime = 15
extra_increment = 0
print(f"will loop for {rangeMax}")
t.sleep(pageSelectTime) # long sleep of pageSelectTime allows for selecting correct subpage of LEARN's report list page
for idx in range(1,numLoops):
    #longer first sleep to allow selecting "do not ask me again for this filetype" checkbox and choosing download option
    SLEEP = 10 if idx == 1 else 0.5
    try:
        report =  driver.find_element_by_xpath(f"/html/body/div[3]/div/div[5]/div/div/d2l-table-wrapper/table/tbody/tr[{idx}]/th/a[1]")
        report.click()
        t.sleep(SLEEP)
    except:
        pass
    print(idx) # allows for progress to be seen from terminal
