import os
import ast
import time as t
import pyautogui as gui
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support.ui import Select
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC

####################
#### Parameters ####
####################

emailAddress = None # email of end user

# values below are required to be non-nil for script to work - redacted for anonymity
REDACTED_UNIVERSITY_LEARN_SITE = None
REDACTED_LEARN_CODE = None

##############
#### Code ####
##############

# load all quiz IDs
quizDict = ast.literal_eval(open("idDictionary.txt","r").read())
quizIDs = []

for valList in quizDict.values():
    for val in valList:
        quizIDs.append(val)

driver = webdriver.Firefox()
driver.get(f"https://{REDACTED_UNIVERSITY_LEARN_SITE}/d2l/custom/ReportingFramework/{REDACTED_LEARN_CODE}/SubmitHome")
gui.typewrite(f"{emailAddress}", interval=0.03)
gui.press("enter")
# have to clear duo manually here
element = WebDriverWait(driver, 50).until(
    EC.presence_of_element_located((By.ID, "ReportSelectBoxID")))

# loop through the form in the "Reporting" subtab, generate all required reports
for studentID in quizIDs:
    driver.get(f"https://{REDACTED_UNIVERSITY_LEARN_SITE}/d2l/custom/ReportingFramework/{REDACTED_LEARN_CODE}/SubmitHome")
    element = WebDriverWait(driver, 50).until(
        EC.presence_of_element_located((By.ID, "ReportSelectBoxID"))
    )
    reportDropDown = Select(driver.find_element_by_id("ReportSelectBoxID"))
    # select R3 - Quizzes
    reportDropDown.select_by_visible_text("R3 - Quizzes")
    t.sleep(5)
    gui.press('tab')
    t.sleep(1)
    gui.press('tab')
    # move to quiz dropdown box

    # enter the ID with both selected
    gui.typewrite(str(studentID))
    t.sleep(1)
    gui.press('tab')
    t.sleep(1)
    gui.press('space')
    t.sleep(3)
    # all of the t.sleeps above allow for page to fully refresh
