import os
import ast
import time as t
import pyautogui as gui
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support.ui import Select    
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC


####################
#### Parameters ####
####################

senderName = None
emailAddress = None # email of end user
courseName = None # name of course, to be inserted in email header
schoolDomain = None # ex. "university.com"

emailBody = "Hello,\nHere is your collected feedback report. It contains all the comments and rankings you have received on your videos.\nIf there are discrepancies between the information in this report and information you have previously received, please let me know.\n Happy Holidays, enjoy your break!\n") # example message for the final report sent to students
signOff = f"Thanks,\n{senderName}" # text to end messages with, ex. "Thanks, have a great day"

##############
#### Code ####
##############

students = ast.literal_eval(open("usernameIDtopicDict.txt").read()) # load dictionary of students

#This requires that the dolphin (or other file manager) window be positioned as the left half of the screen, and the mail window be positioned as the right half.
# serious limitations in the ability to select items by xpath were encountered when parsing outlook website, so pyautogui was used to automate keystrokes instead
# The goal here is to simulate dragging and dropping a report from the file manager on the left-hand side of the screen into the composing email window on the right-hand side to attach the report to the email
# This will require some trial and error to set up, depending on the resolution of the user's screen.

driver = webdriver.Firefox()
driver.get("https://outlook.office365.com/mail/inbox")
t.sleep(3)
gui.typewrite(emailAddress)
gui.press('enter')
element = WebDriverWait(driver,50).until(
        EC.presence_of_element_located((By.XPATH, "/html/body/div[2]/div/div[2]/div[1]/div/div[1]/div[1]/div[2]/button/span")))

t.sleep(15) #initial setup time - allows for elements of webpage to load

for topicnum,uid in students.items():

    # select new mail button
    gui.moveTo(4600,300)
    gui.click()
    t.sleep(5)
    gui.typewrite(f"{uid}@{schoolDomain}") # write student's email address - assumes student's email addresses follow regular pattern

    #move to subject
    gui.press('tab')
    t.sleep(1)
    gui.press('tab')
    t.sleep(1)
    gui.press('tab')
    t.sleep(1)
    gui.press('tab')
    t.sleep(1)
    gui.typewrite(f"{courseName} Feedback Report - Topic {topicnum} - Automated Message ")

    #move to body
    gui.press('tab')
    t.sleep(1)

    #write body 
    gui.typewrite(f"{emailBody}")
    gui.typewrite(f"{signoff}")
    # switch and drag, requires being in the report folder. Dolphin scale slider @ 96px
    # switch to dolphin as active window
    # calls to gui.press() below will need to be customized to suit user's own display manager
    gui.moveTo(3000,350)
    gui.click()
    t.sleep(1)
    # find correct report by searching for a particular topic number
    gui.press('/')
    gui.press('esc')
    gui.press('esc')
    gui.press('/')
    gui.typewrite(topicnum)
    # move to search result
    gui.moveTo(3000,350)
    # drag file visible in search results to email
    gui.dragTo(5900,1100,4,button='left',tween=gui.easeInQuad)
    t.sleep(5)
    gui.moveTo(5900,1100)
    gui.click()
    t.sleep(1)
    gui.press('tab')
    t.sleep(0.5)
    gui.press('tab')
    t.sleep(0.5)
    gui.press('enter') # this click sends message
    t.sleep(5) # sleep time prior to next iteration
